/*
Based on EFF-ZERO BOOST, by Angular 
speeds you up when youre on Sector type 96, Trigger Linedef Executor (Emerald Check)
just to make the last part in Stardust Speedway classic less boring
*/

local stdustclsc = false

addHook("MapLoad", function(mapid)
  stdustclsc = G_BuildMapName(mapid) == "MAPUU"
end)

addHook("NetVars", function(net)
  stdustclsc = net($)
end)


local p, pks, stdBase
local ccoriginal = FRACUNIT

local function stdustclsc_boost(mo)
	if not stdustclsc then return end
	if not(mo and mo.valid and mo.player) then return end
	
	p = mo.player
	pks = mo.player.kartstuff
	
    if P_PlayerTouchingSectorSpecial(p, 2, 6) then -- only do shit when youre on Trigger Linedef Executor (Emerald Check)
		
		ccoriginal = FRACUNIT
		stdBase = 120*FRACUNIT/100 -- 120 should be enough, dont need to go super fast
		
		pks[k_accelboost] = max($, 1/15) --Accel adjust
			
		if pks[k_bananadrag] > TICRATE 
			stdBase = (4*FRACUNIT)/5 -- Forced vanilla value
			ccoriginal = stdBase 
		end
					
		if pks[k_offroad] > 0 and not(pks[k_invincibilitytimer] or pks[k_hyudorotimer] or pks[k_sneakertimer]) 
			stdBase = FixedDiv(ccoriginal, pks[k_offroad] + FRACUNIT) 
		end
				
		pks[k_boostpower] = stdBase
	end		
end

addHook("MobjThinker", stdustclsc_boost, MT_PLAYER)